
#ifndef __ARCH_ARM_SRC_SMARTFUSION2_CHIP_SF2_SYSREG_H
#define __ARCH_ARM_SRC_SMARTFUSION2_CHIP_SF2_SYSREG_H

/* Register Offsets ***********************************************************/

#define SF2_SYSREG_ESRAM_CR_OFFSET           0x00
#define SF2_SYSREG_ESRAM_MAX_LAT_CR_OFFSET   0x04
#define SF2_SYSREG_MAC_EDAC_CR_OFFSET        0X38
#define SF2_SYSREG_SOFT_IRQ_CR_OFFSET        0x44
#define SF2_SYSREG_SOFT_RST_CR_OFFSET        0x48
#define SF2_SYSREG_WDOG_CR_OFFSET            0x6C
#define SF2_SYSREG_MAC_CR_OFFSET             0x8C
#define SF2_SYSREG_MSSDDR_PLL_STATUS_LOW_CR_OFFSET  0x90
#define SF2_SYSREG_MSSDDR_PLL_STATUS_HIGH_CR_OFFSET 0x94
#define SF2_SYSREG_MSSDDR_FACC1_CR_OFFSET    0x98
#define SF2_SYSREG_MSSDDR_FACC2_CR_OFFSET    0x9C
#define SF2_SYSREG_MAC_STAT_CLRONRD_CR_OFFSET   0xAC
#define SF2_SYSREG_MAC_STAT_CLR_CR_OFFSET    0x1AC
#define SF2_SYSREG_MSSDDR_PLL_STATUS_OFFSET  0x150



/* Register Addresses *********************************************************/

#define SF2_SYSREG_ESRAM_CR          (SF2_SYSREG_BASE+SF2_SYSREG_ESRAM_CR_OFFSET)
#define SF2_SYSREG_ESRAM_MAX_LAT_CR  (SF2_SYSREG_BASE+SF2_SYSREG_ESRAM_MAX_LAT_CR_OFFSET)
#define SF2_SYSREG_MAC_EDAC_CR           (SF2_SYSREG_BASE+SF2_SYSREG_MAC_EDAC_CR_OFFSET)
#define SF2_SYSREG_MAC_STAT_CLRONRD_CR   (SF2_SYSREG_BASE+SF2_SYSREG_MAC_STAT_CLRONRD_CR_OFFSET)
#define SF2_SYSREG_SOFT_IRQ_CR       (SF2_SYSREG_BASE+SF2_SYSREG_SOFT_IRQ_CR_OFFSET)
#define SF2_SYSREG_SOFT_RST_CR       (SF2_SYSREG_BASE+SF2_SYSREG_SOFT_RST_CR_OFFSET)
#define SF2_SYSREG_MSSDDR_FACC1_CR   (SF2_SYSREG_BASE+SF2_SYSREG_MSSDDR_FACC1_CR_OFFSET)
#define SF2_SYSREG_MSSDDR_FACC2_CR   (SF2_SYSREG_BASE+SF2_SYSREG_MSSDDR_FACC2_CR_OFFSET)
#define SF2_SYSREG_MSSDDR_PLL_STATUS_LOW_CR (SF2_SYSREG_BASE+SF2_SYSREG_MSSDDR_PLL_STATUS_LOW_CR_OFFSET)
#define SF2_SYSREG_MSSDDR_PLL_STATUS_HIGH_CR (SF2_SYSREG_BASE+SF2_SYSREG_MSSDDR_PLL_STATUS_HIGH_CR_OFFSET)
#define SF2_SYSREG_MSSDDR_PLL_STATUS (SF2_SYSREG_BASE+SF2_SYSREG_MSSDDR_PLL_STATUS_OFFSET)
#define SF2_SYSREG_WDOG_CR           (SF2_SYSREG_BASE+SF2_SYSREG_WDOG_CR_OFFSET)
#define SF2_SYSREG_MAC_CR            (SF2_SYSREG_BASE+SF2_SYSREG_MAC_CR_OFFSET)
#define SF2_SYSREG_MAC_STAT_CLR_CR   (SF2_SYSREG_BASE+SF2_SYSREG_MAC_STAT_CLR_CR_OFFSET)

/* SOFT_RST_CR */
#define SYSREG_SOFTRESET_ENVM0         (1 << 0)
#define SYSREG_SOFTRESET_ENVM1         (1 << 1)
#define SYSREG_SOFTRESET_ESRAM0        (1 << 2)
#define SYSREG_SOFTRESET_ESRAM1        (1 << 3)
#define SYSREG_SOFTRESET_MAC           (1 << 4)
#define SYSREG_SOFTRESET_PDMA          (1 << 5)
#define SYSREG_SOFTRESET_TIMER         (1 << 6)
#define SYSREG_SOFTRESET_MMUART0       (1 << 7)
#define SYSREG_SOFTRESET_MMUART1       (1 << 8)
#define SYSREG_SOFTRESET_SPI0          (1 << 9)
#define SYSREG_SOFTRESET_SPI1          (1 << 10)
#define SYSREG_SOFTRESET_I2C0          (1 << 11)
#define SYSREG_SOFTRESET_I2C1          (1 << 12)
#define SYSREG_SOFTRESET_CAN           (1 << 13)
#define SYSREG_SOFTRESET_USB           (1 << 14)
#define SYSREG_SOFTRESET_COMBLK        (1 << 15)
#define SYSREG_SOFTRESET_FPGA          (1 << 16)
#define SYSREG_SOFTRESET_HPDMA         (1 << 17)
#define SYSREG_SOFTRESET_FIC32_0       (1 << 18)
#define SYSREG_SOFTRESET_FIC32_1       (1 << 19)
#define SYSREG_SOFTRESET_GPIO          (1 << 20)
#define SYSREG_SOFTRESET_GPIO_7_0      (1 << 21)
#define SYSREG_SOFTRESET_GPIO_15_8     (1 << 22)
#define SYSREG_SOFTRESET_GPIO_23_16    (1 << 23)
#define SYSREG_SOFTRESET_GPIO_31_24    (1 << 24)
#define SYSREG_SOFTRESET_MDDR          (1 << 25)
#define SYSREG_SOFTRESET_FIC64         (1 << 26)

/* MAC_CR */

#define SYSREG_MAR_CR_SPEED_SHIFT      (0)
#define SYSREG_MAR_CR_SPEED_MASK       (3)
#  define SYSREG_MAR_CR_SPEED_10       (0)
#  define SYSREG_MAR_CR_SPEED_100      (1)
#  define SYSREG_MAR_CR_SPEED_1000     (2)

#define SYSREG_MAR_CR_MODE_SHIFT       (2)
#define SYSREG_MAR_CR_MODE_MASK        (7 << SYSREG_MAR_CR_MODE_SHIFT)
#  define SYSREG_MAR_CR_MODE_RMII      (0 << SYSREG_MAR_CR_MODE_SHIFT)
#  define SYSREG_MAR_CR_MODE_TBI       (2 << SYSREG_MAR_CR_MODE_SHIFT)
#  define SYSREG_MAR_CR_MODE_MII       (3 << SYSREG_MAR_CR_MODE_SHIFT)
#  define SYSREG_MAR_CR_MODE_GMII      (4 << SYSREG_MAR_CR_MODE_SHIFT)

#define SYSREG_MAC_EDAC_CR_MAC_RTX_SHIFT       (3)
#define SYSREG_MAC_EDAC_CR_MAC_RTX_MASK        (3 << SYSREG_MAC_EDAC_CR_MAC_RTX_SHIFT)
#  define SYSREG_MAC_EDAC_CR_RTX_DISABLE       (0 << SYSREG_MAC_EDAC_CR_MAC_RTX_SHIFT)
#  define SYSREG_MAC_EDAC_CR_RTX_ENABLE        (3 << SYSREG_MAC_EDAC_CR_MAC_RTX_SHIFT)
 
#endif /* __ARCH_ARM_SRC_SMARTFUSION2_CHIP_SF2_SYSREG_H */
